=== debian/changelog ===
gcc-python-plugin (0.14-4) unstable; urgency=medium

  * Build the manual pages on all architectures.

 -- Matthias Klose <doko@debian.org>  Sat, 11 Jul 2015 12:07:24 +0200

gcc-python-plugin (0.14-3) unstable; urgency=medium

  * Build-Depend on python3-all-dbg..

 -- Matthias Klose <doko@debian.org>  Fri, 10 Jul 2015 19:29:31 +0200

gcc-python-plugin (0.14-2) unstable; urgency=medium

  * (Build-)Depend on g++-5.

 -- Matthias Klose <doko@debian.org>  Fri, 10 Jul 2015 16:53:03 +0200

gcc-python-plugin (0.14-1) unstable; urgency=low

  * Initial release (Closes: #787365).

 -- Matthias Klose <doko@debian.org>  Sat, 30 May 2015 10:36:24 +0000
