=== debian/control ===
Source: gcc-python-plugin
Section: devel
Priority: optional
Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
Uploaders: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 9), dh-python,
  gcc-5-plugin-dev, g++-5,
  python3-all-dev, python3-all-dbg, python3-lxml, python3-pygments, python3-six,
#  python-all-dev, python-all-dbg, python-lxml, python-pygments, python-six,
  python3-sphinx
Standards-Version: 3.9.6
Homepage: https://fedorahosted.org/gcc-python-plugin/

Package: gcc-python3-plugin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
  python3-lxml, python3-pygments, python3-six,
  gcc-5, g++-5
Recommends: www-browser, xdg-utils, graphviz
Suggests: gcc-python-plugin-doc
Description: plugin for GCC to invoke Python scripts from inside the compiler
 The GCC Python plugin is a plugin for GCC, which links against libpython,
 and allows you to invoke arbitrary Python scripts from inside the compiler.
 The aim is to allow you to write GCC plugins in Python.

Package: gcc-python3-dbg-plugin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
  gcc-python3-plugin (= ${binary:Version}), python3-lxml-dbg
Suggests: gcc-python-plugin-doc
Description: plugin for GCC to invoke Python scripts from inside the compiler
 The GCC Python plugin is a plugin for GCC, which links against libpython,
 and allows you to invoke arbitrary Python scripts from inside the compiler.
 The aim is to allow you to write GCC plugins in Python.

Package: gcc-python-plugin-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: plugin for GCC to invoke Python scripts from inside the compiler
 The GCC Python plugin is a plugin for GCC, which links against libpython,
 and allows you to invoke arbitrary Python scripts from inside the compiler.
 The aim is to allow you to write GCC plugins in Python.
 .
 This package contains the documentation.
