=== debian/changelog ===
gcc-python-plugin (0.15-4) unstable; urgency=medium

  * Build using GCC 7.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Fri, 08 Sep 2017 11:22:42 +0200

gcc-python-plugin (0.15-3) unstable; urgency=medium

  * Build using GCC 6.

 -- Matthias Klose <doko@debian.org>  Wed, 24 Aug 2016 10:02:56 +0200

gcc-python-plugin (0.15-2) unstable; urgency=medium

  * No-change rebuild. Closes: #818400.

 -- Matthias Klose <doko@debian.org>  Tue, 05 Apr 2016 14:02:19 +0200

gcc-python-plugin (0.15-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sat, 20 Feb 2016 22:15:56 +0100
