=== debian/control ===
--- 
+++ 
@@ -4,18 +4,19 @@
 Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9), dh-python,
-  gcc-5-plugin-dev, g++-5,
+  gcc-7-plugin-dev, g++-7,
   python3-all-dev, python3-all-dbg, python3-lxml, python3-pygments, python3-six,
 #  python-all-dev, python-all-dbg, python-lxml, python-pygments, python-six,
   python3-sphinx
-Standards-Version: 3.9.6
+Standards-Version: 4.1.0
 Homepage: https://fedorahosted.org/gcc-python-plugin/
 
 Package: gcc-python3-plugin
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
   python3-lxml, python3-pygments, python3-six,
-  gcc-5, g++-5
+  gcc-7, g++-7
 Recommends: www-browser, xdg-utils, graphviz
 Suggests: gcc-python-plugin-doc
 Description: plugin for GCC to invoke Python scripts from inside the compiler
@@ -25,6 +26,7 @@
 
 Package: gcc-python3-dbg-plugin
 Architecture: any
+Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
   gcc-python3-plugin (= ${binary:Version}), python3-lxml-dbg
 Suggests: gcc-python-plugin-doc
@@ -35,6 +37,7 @@
 
 Package: gcc-python-plugin-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends}, ${sphinxdoc:Depends}
 Description: plugin for GCC to invoke Python scripts from inside the compiler
