=== debian/watch ===
version=3
https://fedorahosted.org/releases/g/c/gcc-python-plugin/gcc-python-plugin-(.*).tar.gz
