## gcc-python-plugin 0.16

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
-#   Copyright 2011, 2012, 2013 David Malcolm <dmalcolm@redhat.com>
-#   Copyright 2011, 2012, 2013 Red Hat, Inc.
+#   Copyright 2011-2013, 2017 David Malcolm <dmalcolm@redhat.com>
+#   Copyright 2011-2013, 2017 Red Hat, Inc.
 #
 #   This is free software: you can redistribute it and/or modify it
 #   under the terms of the GNU General Public License as published by
@@ -16,7 +16,7 @@
 #   <http://www.gnu.org/licenses/>.
 
 .PHONY: all clean debug dump_gimple plugin show-ssa tarball \
-	test-suite testcpychecker testcpybuilder \
+	test-suite testcpychecker testcpybuilder testdejagnu \
 	man
 
 PLUGIN_SOURCE_FILES= \
@@ -121,7 +121,7 @@
   CPPFLAGS+= -DPLUGIN_PYTHONPATH='"$(PLUGIN_PYTHONPATH)"'
 endif
 
-all: autogenerated-config.h testcpybuilder test-suite testcpychecker
+all: autogenerated-config.h testcpybuilder testdejagnu test-suite testcpychecker
 
 # What still needs to be wrapped?
 api-report:
@@ -276,6 +276,10 @@
 testcpybuilder:
 	$(PYTHON) testcpybuilder.py -v
 
+# Selftest for the dejagnu.py code:
+testdejagnu:
+	$(PYTHON) dejagnu.py -v
+
 dump_gimple:
 	$(CC) -fdump-tree-gimple $(CURDIR)/test.c
 
@@ -289,11 +293,18 @@
 json-examples: plugin
 	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-cpychecker -I/usr/include/python2.7 -c libcpychecker_html/test/example1/bug.c
 
-test-suite: plugin print-gcc-version
+test-suite: plugin print-gcc-version testdejagnu
 	$(INVOCATION_ENV_VARS) $(PYTHON) run-test-suite.py
 
 show-ssa: plugin
 	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-python examples/show-ssa.py test.c
+
+demo-show-lto-supergraph: plugin
+	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-python \
+	  examples/show-lto-supergraph.py \
+	  -flto \
+	  -flto-partition=none \
+	  tests/examples/lto/input-*.c
 
 html: docs/tables-of-passes.rst docs/passes.svg
 	cd docs && $(MAKE) html
@@ -333,11 +344,3 @@
 #
 #  Before tagging:
 #
-#     * update the version/release in docs/conf.py
-#
-#     * update the version in gcc-python-plugin.spec
-#
-#     * add release notes to docs
-#
-#  Test the candidate tarball via a scratch SRPM build locally (this
-#  achieves test coverage against python 2 and 3, for both debug and
