=== debian/changelog ===
gcc-python-plugin (0.16-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sat, 05 May 2018 14:25:56 +0200
