=== debian/control ===
--- 
+++ 
@@ -5,18 +5,19 @@
 Uploaders: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9), dh-python,
   gcc-7-plugin-dev, g++-7,
+  gcc-8-plugin-dev, g++-8,
   python3-all-dev, python3-all-dbg, python3-lxml, python3-pygments, python3-six,
 #  python-all-dev, python-all-dbg, python-lxml, python-pygments, python-six,
   python3-sphinx
-Standards-Version: 4.1.0
-Homepage: https://fedorahosted.org/gcc-python-plugin/
+Standards-Version: 4.1.4
+Homepage: https://github.com/davidmalcolm/gcc-python-plugin
 
 Package: gcc-python3-plugin
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
   python3-lxml, python3-pygments, python3-six,
-  gcc-7, g++-7
+  gcc-7 | gcc-8, g++-7 | g++-8
 Recommends: www-browser, xdg-utils, graphviz
 Suggests: gcc-python-plugin-doc
 Description: plugin for GCC to invoke Python scripts from inside the compiler
