=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,7 @@
 # -*- makefile -*-
 
 CC 	= gcc-7
+ALT_CC 	= gcc-8
 PYTHON	= python
 p3	= gcc-python3-plugin
 d3	= debian/$(p3)
@@ -29,6 +30,18 @@
 	  PLUGIN_DSO=$(subst -,_,$*.so) \
 	  PLUGIN_PYTHONPATH=$(shell $(CC) --print-file-name=plugin)/$(subst -,_,$*) \
 	  plugin print-gcc-version
+ifneq (,$(ALT_CC))
+	rm -rf build-alt-$*
+	mkdir -p build-alt-$*
+	tar -c -f - --exclude=debian --exclude=build-* . | tar -C build-alt-$* -x -f -
+	$(MAKE) -C build-alt-$* \
+	  CC=$(ALT_CC) \
+	  PYTHON=$* PYTHON_CONFIG=$*-config \
+	  PLUGIN_NAME=$(subst -,_,$*) \
+	  PLUGIN_DSO=$(subst -,_,$*.so) \
+	  PLUGIN_PYTHONPATH=$(shell $(CC) --print-file-name=plugin)/$(subst -,_,$*) \
+	  plugin print-gcc-version
+endif
 	touch $@
 
 check-stamp-%: build-stamp-%
@@ -41,6 +54,15 @@
 	  PLUGIN_DSO=$(subst -,_,$*.so) \
 	  PLUGIN_PYTHONPATH=$(shell $(CC) --print-file-name=plugin)/$(subst -,_,$*) \
 	  all
+ifneq (,$(ALT_CC))
+	-$(MAKE) -C build-alt-$* \
+	  CC=$(ALT_CC) \
+	  PYTHON=$* PYTHON_CONFIG=$*-config \
+	  PLUGIN_NAME=$(subst -,_,$*) \
+	  PLUGIN_DSO=$(subst -,_,$*.so) \
+	  PLUGIN_PYTHONPATH=$(shell $(CC) --print-file-name=plugin)/$(subst -,_,$*) \
+	  all
+endif
 	touch $@
 
 doc-stamp:
@@ -51,7 +73,7 @@
 clean: 
 	dh_testdir
 	dh_testroot
-	rm -f build-stamp* check-stamp* doc-stamp
+	rm -f build*-stamp* check*-stamp* doc-stamp
 	rm -rf build-*
 	$(MAKE) -C docs clean
 	find -type d -name __pycache__ | xargs -r rm -rf
@@ -67,6 +89,31 @@
 install-%: build-stamp-%
 	dh_testdir
 	dh_testroot
+ifneq (,$(ALT_CC))
+	$(MAKE) -C build-alt-$* \
+	  CC=$(ALT_CC) \
+	  PYTHON=$* PYTHON_CONFIG=$*-config \
+	  PLUGIN_NAME=$(subst -,_,$*) \
+	  PLUGIN_DSO=$(subst -,_,$*.so) \
+	  PLUGIN_PYTHONPATH=$(shell $(CC) --print-file-name=plugin)/$(subst -,_,$*) \
+	  DESTDIR=$(CURDIR)/debian/gcc-$*-plugin \
+	  install
+	set -x; \
+	p="gcc-$*-plugin"; \
+	src="$(shell $(ALT_CC) --print-file-name=plugin)/$(subst -,_,$*)"; \
+	dst="usr/lib/$(if $(findstring python3, $*),python3,python2.7)/dist-packages"; \
+	mkdir -p debian/$$p/$$dst; \
+	for d in gccutils libcpychecker; do \
+	  tar -C debian/$$p/$$src -c -f - $$d \
+	    | tar -C debian/$$p/$$dst -x -f -; \
+	  rm -rf debian/$$p/$$src/$$d; \
+	  dh_link -p$$p /$$dst/$$d /$$src/$$d; \
+	done; \
+	$(if $(findstring dbg,$*), \
+	  rm -f debian/$$p/$$src/../libgcc-c-api.so; \
+	  rm -rf debian/$$p/$$dst; \
+	)
+endif
 	$(MAKE) -C build-$* \
 	  CC=$(CC) \
 	  PYTHON=$* PYTHON_CONFIG=$*-config \
