## gcc-python-plugin 0.17

=== Makefile ===
--- 
+++ 
@@ -14,6 +14,12 @@
 #   You should have received a copy of the GNU General Public License
 #   along with this program.  If not, see
 #   <http://www.gnu.org/licenses/>.
+
+ifneq ($(srcdir),)
+VPATH = $(srcdir)
+endif
+xmldir = $(srcdir)./gcc-c-api/
+pwd = $(shell pwd -P)
 
 .PHONY: all clean debug dump_gimple plugin show-ssa tarball \
 	test-suite testcpychecker testcpybuilder testdejagnu \
@@ -132,7 +138,7 @@
 # When running the plugin from a working copy, use LD_LIBARY_PATH=gcc-c-api
 # so that the plugin can find its libgcc-c-api.so there
 #
-INVOCATION_ENV_VARS := LD_LIBRARY_PATH=gcc-c-api CC=$(CC)
+INVOCATION_ENV_VARS := PYTHONPATH=$(srcdir)./ CC_FOR_CPYCHECKER=$(CC) LD_LIBRARY_PATH=gcc-c-api:$(LD_LIBRARY_PATH) CC=$(CC)
 
 # When installing, both the plugin and libgcc-c-api.so will be installed to
 # $(GCCPLUGINS_DIR), so we give the plugin an RPATH of $(GCCPLUGINS_DIR)
@@ -148,15 +154,18 @@
 	    $(LIBS) \
 	    -lgcc-c-api -Lgcc-c-api -Wl,-rpath=$(GCCPLUGINS_DIR)
 
-$(LIBGCC_C_API_SO):
-	cd gcc-c-api && make libgcc-c-api.so CC=$(CC)
+$(pwd)/gcc-c-api:
+	mkdir -p $@
+
+$(LIBGCC_C_API_SO): $(pwd)/gcc-c-api
+	cd gcc-c-api && make $(if $(srcdir),-f $(srcdir)./gcc-c-api/Makefile) libgcc-c-api.so CC=$(CC) $(if $(srcdir),srcdir=$(srcdir)./gcc-c-api/)
 
 $(PLUGIN_OBJECT_GENERATED_FILES): CPPFLAGS+= $(if $(srcdir),-I$(srcdir))
 
 # This is the standard .c->.o recipe, but it needs to be stated
 # explicitly to support the case that $(srcdir) is not blank.
-$(PLUGIN_OBJECT_SOURCE_FILES) $(PLUGIN_OBJECT_GENERATED_FILES): %.o: $(srcdir)%.c autogenerated-config.h $(srcdir)gcc-python.h $(LIBGCC_C_API_SO) autogenerated-EXTRA_CFLAGS.txt
-	$(COMPILE.c) $(shell cat autogenerated-EXTRA_CFLAGS.txt) $(OUTPUT_OPTION) $<
+$(PLUGIN_OBJECT_FILES): %.o: %.c autogenerated-config.h gcc-python.h $(LIBGCC_C_API_SO) autogenerated-EXTRA_CFLAGS.txt
+	$(COMPILE.c) $(shell cat autogenerated-EXTRA_CFLAGS.txt) $(OUTPUT_OPTION) -I$(srcdir)./ -I$(srcdir)./gcc-c-api -I./gcc-c-api $<
 
 print-gcc-version: print-gcc-version.c autogenerated-EXTRA_CFLAGS.txt
 	$(CC) \
@@ -173,10 +182,10 @@
 	cd gcc-c-api && make clean
 	find tests -name "*.o" -delete
 
-autogenerated-config.h: $(addprefix $(srcdir),generate-config-h.py configbuilder.py)
+autogenerated-config.h: generate-config-h.py configbuilder.py
 	$(PYTHON) $< -o $@ --gcc="$(CC)" --plugindir="$(GCCPLUGINS_DIR)"
 
-autogenerated-%.txt: $(srcdir)%.txt.in
+autogenerated-%.txt: %.txt.in
 	$(CPP) $(CPPFLAGS) -x c-header $^ -o $@
 
 # autogenerated-EXTRA_CFLAGS.txt is a byproduct of making
@@ -186,16 +195,16 @@
 # autogenerated-casts.h is a byproduct of making autogenerated-casts.c
 autogenerated-casts.h: autogenerated-casts.c
 
-$(PLUGIN_GENERATED_SOURCE_FILES): autogenerated-%.c: $(addprefix $(srcdir),generate-%-c.py $(GENERATOR_DEPS))
+$(PLUGIN_GENERATED_SOURCE_FILES): autogenerated-%.c: generate-%-c.py $(GENERATOR_DEPS)
 	$(PYTHON) $< > $@
 
-autogenerated-casts.c:  autogenerated-gimple-types.txt autogenerated-tree-types.txt autogenerated-rtl-types.txt $(srcdir)generate-casts-c.py
-	$(PYTHON) $(srcdir)generate-casts-c.py autogenerated-casts.c autogenerated-casts.h
-
-autogenerated-gimple.c: autogenerated-gimple-types.txt autogenerated-tree-types.txt autogenerated-rtl-types.txt $(srcdir)maketreetypes.py
-autogenerated-tree.c: autogenerated-tree-types.txt $(srcdir)maketreetypes.py
-autogenerated-rtl.c: autogenerated-rtl-types.txt $(srcdir)maketreetypes.py
-autogenerated-variable.c: autogenerated-gimple-types.txt $(srcdir)maketreetypes.py
+autogenerated-casts.c:  autogenerated-gimple-types.txt autogenerated-tree-types.txt autogenerated-rtl-types.txt generate-casts-c.py
+	PYTHONPATH=$(srcdir)./gcc-c-api	$(PYTHON) $(srcdir)generate-casts-c.py autogenerated-casts.c autogenerated-casts.h $(xmldir)
+
+autogenerated-gimple.c: autogenerated-gimple-types.txt autogenerated-tree-types.txt autogenerated-rtl-types.txt maketreetypes.py
+autogenerated-tree.c: autogenerated-tree-types.txt maketreetypes.py
+autogenerated-rtl.c: autogenerated-rtl-types.txt maketreetypes.py
+autogenerated-variable.c: autogenerated-gimple-types.txt maketreetypes.py
 
 bindir=/usr/bin
 mandir=/usr/share/man
@@ -270,15 +279,15 @@
 
 # Selftest for the cpychecker.py code:
 testcpychecker: plugin
-	$(INVOCATION_ENV_VARS) $(PYTHON) testcpychecker.py -v
+	$(INVOCATION_ENV_VARS) $(PYTHON) $(srcdir)./testcpychecker.py -v
 
 # Selftest for the cpybuilder code:
 testcpybuilder:
-	$(PYTHON) testcpybuilder.py -v
+	$(PYTHON) $(srcdir)./testcpybuilder.py -v
 
 # Selftest for the dejagnu.py code:
 testdejagnu:
-	$(PYTHON) dejagnu.py -v
+	$(PYTHON) $(srcdir)./dejagnu.py -v
 
 dump_gimple:
 	$(CC) -fdump-tree-gimple $(CURDIR)/test.c
@@ -286,15 +295,35 @@
 debug: plugin
 	$(INVOCATION_ENV_VARS) $(CC) -v $(TEST_CFLAGS) $(CURDIR)/test.c
 
+$(pwd)/gcc-with-cpychecker: gcc-with-cpychecker
+	cp $< $@
+
 # A simple demo, to make it easy to demonstrate the cpychecker:
-demo: plugin
-	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-cpychecker -c $(PYTHON_INCLUDES) demo.c
+demo: demo.c plugin $(pwd)/gcc-with-cpychecker
+	$(INVOCATION_ENV_VARS) ./gcc-with-cpychecker -c $(PYTHON_INCLUDES) $<
+
+# Run 'demo', and verify the output.
+testdemo: DEMO_REF=$(shell \
+	if [ $$(./print-gcc-version) -ge 7000 ]; then \
+		echo demo.expected.no-refcounts; \
+	else \
+		echo demo.expected; \
+	fi)
+testdemo: plugin print-gcc-version
+	$(MAKE) -f $(srcdir)./Makefile demo > demo.out 2> demo.err
+	egrep '^.*demo.c:( In function |[0-9][0-9]*:[0-9][0-9]*: warning:)' \
+	  demo.err \
+	  | sed 's/:[0-9][0-9]*: warning:/:: warning:/;s/ \[enabled by default\]//' \
+	  | sed "s%$(srcdir)demo.c:%demo.c:%g" \
+	  > demo.filtered
+	diff $(srcdir)./$(DEMO_REF) demo.filtered
+	rm demo.out demo.err demo.filtered
 
 json-examples: plugin
 	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-cpychecker -I/usr/include/python2.7 -c libcpychecker_html/test/example1/bug.c
 
-test-suite: plugin print-gcc-version testdejagnu
-	$(INVOCATION_ENV_VARS) $(PYTHON) run-test-suite.py
+test-suite: plugin print-gcc-version testdejagnu testdemo
+	$(INVOCATION_ENV_VARS) $(PYTHON) $(srcdir)./run-test-suite.py $(if $(srcdir),--srcdir=$(srcdir))
 
 show-ssa: plugin
 	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-python examples/show-ssa.py test.c
@@ -312,35 +341,3 @@
 # We commit this generated file to SCM to allow the docs to be built without
 # needing to build the plugin:
 docs/tables-of-passes.rst: plugin generate-tables-of-passes-rst.py
-	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-python generate-tables-of-passes-rst.py test.c > $@
-
-# Likewise for this generated file:
-docs/passes.svg: plugin generate-passes-svg.py
-	$(INVOCATION_ENV_VARS) $(srcdir)./gcc-with-python generate-passes-svg.py test.c
-
-check-api:
-	xmllint --noout --relaxng $(srcdir)./gcc-c-api/api.rng $(srcdir)./gcc-c-api/*.xml
-
-# Utility target, to help me to make releases
-#   - creates a tag in git (but does not push it; see "Notes to self on
-#     making a release" below)
-#   - creates a tarball
-#
-# The following assumes that VERSION has been set e.g.
-#   $ make tarball VERSION=0.4
-
-$(HOME)/rpmbuild/SOURCES/%.tar.gz:
-	test -n "$(VERSION)"
-	-git tag -d v$(VERSION)
-	git tag -a v$(VERSION) -m"$(VERSION)"
-	git archive --format=tar --prefix=$*/ v$(VERSION) | gzip > $*.tar.gz
-	sha256sum $*.tar.gz
-	cp $*.tar.gz $@
-
-tarball: $(HOME)/rpmbuild/SOURCES/gcc-python-plugin-$(VERSION).tar.gz
-
-# Notes to self on making a release
-# ---------------------------------
-#
-#  Before tagging:
-#
