=== gcc-c-api/Makefile ===
--- 
+++ 
@@ -14,6 +14,11 @@
 #   You should have received a copy of the GNU General Public License
 #   along with this program.  If not, see
 #   <http://www.gnu.org/licenses/>.
+
+ifneq ($(srcdir),)
+VPATH = $(srcdir)
+endif
+xmldir = $(srcdir)./
 
 .PHONY: all clean check-api
 
@@ -45,6 +50,7 @@
   cfg.xml \
   constant.xml \
   declaration.xml \
+  diagnostics.xml \
   function.xml \
   gimple.xml \
   location.xml \
@@ -88,11 +94,11 @@
 
 # This is the standard .c->.o recipe, but it needs to be stated
 # explicitly to support the case that $(srcdir) is not blank.
-$(OBJECT_FILES): %.o: $(srcdir)%.c $(GENERATED_HEADERS) ../autogenerated-EXTRA_CFLAGS.txt
-	$(COMPILE.c) $(shell cat ../autogenerated-EXTRA_CFLAGS.txt) $(OUTPUT_OPTION) $<
+$(OBJECT_FILES): %.o: %.c $(GENERATED_HEADERS) ../autogenerated-EXTRA_CFLAGS.txt
+	$(COMPILE.c) $(shell cat ../autogenerated-EXTRA_CFLAGS.txt) $(OUTPUT_OPTION) -I$(srcdir)./ $<
 
 autogenerated-casts.c: $(SOURCE_XML) xmltypes.py generate-casts-c.py
-	$(PYTHON) generate-casts-c.py $@
+	$(PYTHON) $(srcdir)./generate-casts-c.py $@ $(xmldir)
 
 clean:
 	$(RM) *.so *.o $(GENERATED_HEADERS)
@@ -105,7 +111,7 @@
 PYTHON=python
 
 $(GENERATED_HEADERS): $(SOURCE_XML) xml-to-h.py xmltypes.py
-	$(PYTHON) xml-to-h.py
+	$(PYTHON) $(srcdir)./xml-to-h.py $(xmldir)
 
 check-api:
 	xmllint --noout --relaxng api.rng *.xml
