=== debian/changelog ===
gcc-python-plugin (0.17-6ubuntu2) jammy; urgency=medium

  * Remove dependency from dbg package to removed python3-lxml-dbg

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 16 Dec 2021 11:31:58 +0100

gcc-python-plugin (0.17-6ubuntu1) jammy; urgency=medium

  * Don't fail the build on deprecated python functions.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 19 Nov 2021 19:24:09 +0000

gcc-python-plugin (0.17-6build2) jammy; urgency=medium

  * No-change rebuild to add python3.10.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 17 Oct 2021 12:21:20 +0200

gcc-python-plugin (0.17-6) unstable; urgency=medium

  * debian/patches/python3.8-compat.patch: fix compatibility with
    Python 3.8 (Steve Langasek). Closes: #951752.

 -- Matthias Klose <doko@debian.org>  Sun, 05 Apr 2020 15:40:16 +0200

gcc-python-plugin (0.17-5) unstable; urgency=medium

  * Ignore a compiler warning seen with Python 3.8.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Thu, 20 Feb 2020 14:15:45 +0100

gcc-python-plugin (0.17-4) unstable; urgency=medium

  * Stop building for GCC 8.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Tue, 05 Nov 2019 10:53:18 +0100

gcc-python-plugin (0.17-3) unstable; urgency=medium

  * Build for GCC 9.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Sat, 20 Jul 2019 01:12:02 +0200

gcc-python-plugin (0.17-2) unstable; urgency=medium

  * Fix build failure with GCC 8.3. Closes: #924097.

 -- Matthias Klose <doko@debian.org>  Sat, 09 Mar 2019 18:31:48 +0100

gcc-python-plugin (0.17-1ubuntu1) disco; urgency=medium

  * Build for GCC 9 as well.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Feb 2019 09:17:36 +0100

gcc-python-plugin (0.17-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Thu, 24 Jan 2019 09:27:49 +0100

gcc-python-plugin (0.16-2) unstable; urgency=medium

  * Stop building for GCC 7.

 -- Matthias Klose <doko@debian.org>  Sat, 21 Jul 2018 13:35:19 +0200
