=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: gcc-python-plugin
 Section: devel
 Priority: optional
-Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
 Uploaders: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9), dh-python,
-  gcc-7-plugin-dev, g++-7,
-  gcc-8-plugin-dev, g++-8,
+  gcc-9-plugin-dev, g++-9,
+  gcc-10-plugin-dev, g++-10,
   python3-all-dev, python3-all-dbg, python3-lxml, python3-pygments, python3-six,
-#  python-all-dev, python-all-dbg, python-lxml, python-pygments, python-six,
   python3-sphinx
-Standards-Version: 4.1.4
+Standards-Version: 4.5.0
 Homepage: https://github.com/davidmalcolm/gcc-python-plugin
 
 Package: gcc-python3-plugin
@@ -17,7 +17,7 @@
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
   python3-lxml, python3-pygments, python3-six,
-  gcc-7 | gcc-8, g++-7 | g++-8
+  g++-9
 Recommends: www-browser, xdg-utils, graphviz
 Suggests: gcc-python-plugin-doc
 Description: plugin for GCC to invoke Python scripts from inside the compiler
@@ -29,7 +29,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends},
-  gcc-python3-plugin (= ${binary:Version}), python3-lxml-dbg
+  gcc-python3-plugin (= ${binary:Version})
 Suggests: gcc-python-plugin-doc
 Description: plugin for GCC to invoke Python scripts from inside the compiler
  The GCC Python plugin is a plugin for GCC, which links against libpython,
