=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,8 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
 
-CC 	= gcc-7
-ALT_CC 	= gcc-8
+CC 	= gcc-9
+#ALT_CC 	= gcc-10
 PYTHON	= python
 p3	= gcc-python3-plugin
 d3	= debian/$(p3)
@@ -14,6 +14,7 @@
 INTERP	= python3 python3-dbg # python python-dbg
 
 export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
+export CFLAGS := $(shell env DEB_CFLAGS_MAINT_APPEND=-Wno-error=deprecated-declarations dpkg-buildflags --get CFLAGS)
 
 build-arch: $(INTERP:%=build-stamp-%)
 build-indep: doc-stamp
