=== debian/watch ===
version=3
https://github.com/davidmalcolm/gcc-python-plugin/tags .*/v?(\d\S+)\.tar\.gz
